#ifndef Chat_H
#define Chat_H

#include <KSGNetwork.h>
#include <TextFeld.h>
#include <Rahmen.h>
#include <UIInitialization.h>

using namespace Framework;

class SpielChat : public virtual ReferenceCounter
{
private:
    LRahmen *rahmen = 0;
    TextFeld *verlauf;
    TextFeld *nachricht;

public:
    // Konstruktor
    SpielChat( UIInit &uiFactory );
    // Destruktor
    ~SpielChat();
    // nicht constant
    void addNachricht( char *nachricht );
    void addNachricht( char *nachricht, int farbe );
    void doPublicMausEreignis( MausEreignis &me );
    void doTastaturEreignis( TastaturEreignis &te, KSGClient::SpielServerClient *zKlient );
    void tick( double z );
    void render( Bild &zRObj );
    // constant
    bool istAktiv() const;
};

#endif